/*
 * lcd_eeprom.c
 *
 * Created: 2016. 09. 07. 9:16:29
 * Author : AradiSzilard
 */ 

/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "lcd.h"
#include "eeprom.h"
#include "timer.h"
#include "adc.h"

/******************************************************************************
* Macros
******************************************************************************/
#define OK 0
#define BAD_ADDR 1
#define TRUE 1
#define FALSE 0
/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Global Variables
******************************************************************************/

extern uint8_t timer_5ms=FALSE,timer_10ms=FALSE,timer_53ms=FALSE,timer_103ms=FALSE,timer_1000ms=FALSE, timer_A_task=FALSE, timer_B_task=FALSE;
extern volatile uint16_t ADCresult;
extern uint16_t A=0,B=0;
uint8_t szamlalo=0;
uint8_t a=0,b=7;
uint8_t adir=0, bdir=1;
char write_string[100]={};

/******************************************************************************
* External Variables
******************************************************************************/


/******************************************************************************
* Local Function Declarations
******************************************************************************/


/******************************************************************************
* Local Function Definitions
******************************************************************************/




int main(void)
{
	DDRA=0xFF;
	DDRB=0xFF;
	DDRE= (0<<PE4) | (0<<PE5);
	
	PORTE= (1<<PE4) | (1<<PE5);
	PORTA=0x01;
	PORTB=0x80;
	
	EICRB= (1<<ISC41) | (1<<ISC51);
	EIMSK= (1<<INT4) | (1<<INT5);
	
	
	lcdinit();
	EEPROM_read(100,&szamlalo);
	timer_init();
	ADC_Init();
	sei();
	
	uint8_t al,ah,bl,bh;
	EEPROM_read(100,&al);
	EEPROM_read(101,&ah);
	EEPROM_read(102,&bl);
	EEPROM_read(103,&bh);
	A=al | ((uint16_t)ah<<8);
	B=bl | ((uint16_t)bh<<8);
	
	while(1)
	{
		if(timer_A_task)
		{
			if(adir==0)
			{	
				PORTA = (PORTA << 1);
				a++;
			}
			else 
			{
				PORTA = (PORTA >> 1);
				a--;
			}
			
			if(a==7) adir=1; 
			if(a==0) adir=0;
			
			
			timer_A_task=FALSE;
		}

		if(timer_B_task)
		{
			
			if(bdir==0)
			{
				PORTB = (PORTB << 1);
				b++;
			}
			else
			{
				PORTB = (PORTB >> 1);
				b--;
			}
			
			if(b==7) bdir=1;
			if(b==0) bdir=0;
			
			timer_B_task=FALSE;
		}
		
		
		if(timer_5ms)
		{
			
			timer_5ms=FALSE;
		}
		
		if(timer_10ms)
		{
			timer_10ms=FALSE;
		}
		
		if(timer_53ms)
		{
			EEPROM_write(100,(A & 0x00FF));
			EEPROM_write(101,(A & 0xFF00)>>8);
			EEPROM_write(102,(B & 0x00FF));
			EEPROM_write(103,(B & 0xFF00)>>8);
			
			timer_53ms=FALSE;
		}
		
		if(timer_103ms)
		{
			sprintf(write_string,"P:%d,A:%d,B:%d",(uint16_t)((ADCresult)*1.3685)+100, A,B);
			lcdreir(write_string);
			lcd_rethome();
			
			/*if (OK==EEPROM_read(100,&szamlalo))
			{
				sprintf(write_string,"%d   ",szamlalo);
				lcdreir(write_string);
				lcd_rethome();
			}
			else
			{
				lcdreir("Hibas cim!");
				lcd_rethome();
			}*/
			
			timer_103ms=FALSE;
		}
		
		if(timer_1000ms)
		{
			
			
			
			
			/*szamlalo++;
			if(BAD_ADDR==EEPROM_write(100,szamlalo))
			{
				lcdreir("Hibas cim!");
				lcd_rethome();
			}*/
			timer_1000ms=FALSE;
		}
		
	}
}

ISR (INT4_vect)    // EXTINT0
{
	A=(uint16_t)((ADCresult)*1.3685)+100;
}

ISR (INT5_vect)    // EXTINT0
{
	B=(uint16_t)((ADCresult)*1.3685)+100;
}
