/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <stdio.h>


#define TRUE 1
#define FALSE 0

uint8_t timer_5ms,timer_10ms,timer_53ms,timer_103ms,timer_1000ms, timer_A_task, timer_B_task;
uint16_t ido=0;
uint16_t A,B;

/******************************************************************************
* Function:         void timer_init(void)
* Description:		Timer inicializlsa
* Input:
* Output:
* Notes:
******************************************************************************/
void timer_init(void)
{
	TCCR0A=0b00001011;
	OCR0A=125;
	TIMSK0=0b00000010;
}

/******************************************************************************
* Interrupt Routines
******************************************************************************/

/******************************************************************************
* Function:			ISR(TIMER0_COMP_vect)
* Description:		Timer0 Output Compare megszakts
* Input:
* Output:
* Notes:
******************************************************************************/
ISR(TIMER0_COMP_vect)
{
	if(!(ido % 5))
	{
		timer_5ms=TRUE;
	}
	if(!(ido % 10))
	{
		timer_10ms=TRUE;
	}
	if(!(ido % 53))
	{
		timer_53ms=TRUE;
	}
	if(!(ido % 103))
	{
		timer_103ms=TRUE;
	}
	if(!(ido % 1000))
	{
		timer_1000ms=TRUE;
	}

	if(!(ido % A))
	{
		timer_A_task=TRUE;
	}
	if(!(ido % B))
	{
		timer_B_task=TRUE;
	}

	ido++;
}